from tic.shared.utils.date_util import (
    to_iso_8601,
    match_str_strptime_to_datetime,
    utc_now,
)
from tic.reputation.shared.enums.signature_status import SignatureStatus
from tic.shared.dto import Dto

import datetime


class ReffReputation(Dto):
    decode_settings = {
        "feed_date": lambda x: utc_now()
        if x is None
        else match_str_strptime_to_datetime(x),
        "signature_status": lambda x: SignatureStatus.UNKNOWN
        if x is None
        else SignatureStatus(x),
    }

    encode_settings = {
        "feed_date": lambda x: to_iso_8601(x),
        "signature_status": lambda x: SignatureStatus.UNKNOWN.value
        if x is None
        else x.value,
    }

    def __init__(
        self,
        reputation_score: [int, None] = None,
        detection_name: [str, None] = None,
        publisher_name: [str, None] = None,
        cb_classification: [str, None] = None,
        feed_date: [datetime, None] = None,
        signature_status: SignatureStatus = None,
        rule_id: [str, None] = None,
    ):
        self.reputation_score = reputation_score
        self.detection_name = detection_name
        self.publisher_name = publisher_name
        self.cb_classification = cb_classification
        self.feed_date = (feed_date,)
        self.signature_status = signature_status
        self.rule_id = rule_id
